/***************************************************************************
*   Copyright (C) 2004 by Christoph Thielecke                             *
*   crissi99@gmx.de                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef OPENVPNMANAGEMENTHANDLER_H
#define OPENVPNMANAGEMENTHANDLER_H

#include <stdlib.h>
#include <tqsocket.h>
#include <tqtimer.h>
#include "kvpncconfig.h"


class TQSocket;

/**
	@author Christoph Thielecke <crissi99@gmx.de>
*/
class OpenvpnManagementHandler : public TQObject {
		TQ_OBJECT
  
	public:
		OpenvpnManagementHandler(TQObject *parent, KVpncConfig *GlobalConfig );
		~OpenvpnManagementHandler();
		void closeConnection();
		bool isConnectedToManagementPort();
		bool doConnect();
		TQTimer greetingtimer;
		bool socketReallyClosed;

	protected slots:
		void socketConnected();
		void socketConnectionClosed();
		void socketError( int );
		void socketReadyRead();
		void socketClosed();
		void hostFound();
		void greetingTimedOut();

	public slots:
		void sendToServer(TQString cmd);

	private:
		KVpncConfig *GlobalConfig;
		bool fInHold;
		bool gotGreeting;
		bool connectedToManagementPort;
		TQSocket *socket;
		TQString errormsg;
	signals:
		void terminate_openvpn();

};
#endif

